{% extends 'test_base_2.html' %}

{% block title %} Dashboard {% endblock %}

<!-- Specific Page CSS goes HERE  -->
{% block stylesheets %}
    <link href="/static/assets/css/app.css" rel="stylesheet">
    <link href="/static/assets/css/ml_model.css" rel="stylesheet">
{% endblock %}

{% block content %}

<main class="content">

    <div class="container-fluid p-0">

        <div class="row mb-2 mb-xl-3">
            <div class="col-auto d-none d-sm-block">
                <h3><strong>Machine Learning</strong> Model</h3>
            </div>

            <div class="col-auto ml-auto text-right mt-n1">
                <nav aria-label="breadcrumb">
                    <ol class="breadcrumb bg-transparent p-0 mt-1 mb-0">
                        <li class="breadcrumb-item"><a href="/">Saviour</a></li>
                        <li class="breadcrumb-item active" aria-current="page">Analyse</li>
                    </ol>
                </nav>
            </div>
        </div>
    </div>
    
    <!-- //button -->
    <div class="container-fluid with-padding">
        <div class="row">
            <div class="col-auto">
                <button type="button" class="btn btn-primary" disabled>Modell wird trainiert...</button>
            </div>
            <div class="col-auto">
                <h5 id="training_finished_hint"></h5>
            </div>
        </div>
    </div>

    <div class="container-fluid with-padding">
        <div class="progress">
            <div class="progress-bar" role="progressbar" id="progressBar" aria-valuenow="0" aria-valuemin="0" aria-valuemax="100" style="width:0%">
                Laden...
            </div>
        </div>
    </div>

    <div class="container-fluid with-padding">
        <h5>Graphen</h5>
        {% for i in ["Zugfestigkeit [N]", "Bruchdehnung [%]", "Schlagzähigkeit [J]", "Geometrische Genauigkeit"] %}
        <div class="row">
            <div class="col-auto">
                <h5 class="card-title mb-0">{{i}}:</h5>
            </div>
            <div class="col-auto">
                <a href="/machine-learning-model/show_diagramm/{{i}}/model" id=test><button type="button" class="btn btn-primary">Model Performance</button></a>
            </div>
            <div class="col-auto">
                <a href="/machine-learning-model/show_diagramm/{{i}}/PFI Importance" id=test><button type="button" class="btn btn-primary">Feature Importance</button></a>
            </div>
            <div class="col-auto">
                <a href="/machine-learning-model/show_diagramm/{{i}}/PDP Importance" id=test><button type="button" class="btn btn-primary">Abhängigkeiten</button></a>
            </div>
        </div>
        {% endfor %}
    </div>

    <div class="container-fluid with-padding">
        <h5>Aktuell wird dargestellt: </h5>
        <p>{{graph_name}}</p>
        <div id="chart0" class="chart"></div>
    </div>

</main>

{% endblock content %}

<!-- Specific Page JS goes HERE  -->
{% block javascripts %}

<script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-kenU1KFdBIe4zVF0s0G1M5b4hcpxyD9F7jL+jjXkk+Q2h455rYXK/7HAuoJl+0I4" crossorigin="anonymous"></script>


<script src="//ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.min.js"></script>
<script type=text/javascript>
        $(function() {
          $('a#button_train').on('click', function(e) {
            e.preventDefault()
            $.getJSON('/train_model_calculate_results',
                function(data) {
              //do nothing
            });
            return false;
          });
        });
</script>


<script>
    var timeout;
    
    /**
     * Function to get status for progress bar.
     */
    async function getStatus() {
      let get;
      try {
        const res = await fetch("/status");
        get = await res.json();
      } catch (e) {
        console.error("Error: ", e);
      }
      
      document.getElementById("progressBar").innerHTML = get.status + "&percnt;";
      document.getElementById("progressBar").setAttribute("aria-valuenow", get.status);
      document.getElementById("progressBar").style.width = get.status + '%';
      
      if (get.status == 100){
        document.getElementById("progressBar").innerHTML += " Abgeschlossen.";
        document.getElementById("training_finished_hint").innerHTML = "Das Training wurde erfolgreich abgeschlossen. Um ein neues Training zu starten laden Sie diese Seite neu.";
        clearTimeout(timeout);
        return false;
      }
       
      timeout = setTimeout(getStatus, 1000);
    }
    
    getStatus();
</script>


<script src='https://cdn.plot.ly/plotly-latest.min.js'></script>
<script>
    var graph = {{graph | safe}};
    Plotly.plot('chart0',graph,{});
</script>


{% endblock javascripts %}
